/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Loesung der Uebungsaufgabe Kapitel 8, Nr. 6                 */
/* aus "C fuer Java-Programmierer", Hanser-Verlag.             */
/***************************************************************/

#include <stdlib.h>

/*** Funktionen fuer Listendarstellung ***/

typedef struct listenknoten_dop {
  int  wert;
  struct listenknoten_dop  *prev;
  struct listenknoten_dop  *next;
} listenknoten_dop;

void ausgabe_liste(listenknoten_dop *kopf) {
 listenknoten_dop *laufzeiger;
 if (kopf==NULL) { printf(" leer\n"); return; }
 laufzeiger = kopf;
 do {
  printf(" %d",laufzeiger->wert);
  laufzeiger = laufzeiger->next;
 }
 while (laufzeiger!=kopf);
 printf("\n");
}

int einfuegen_liste(listenknoten_dop **kopf, int wert) {
 listenknoten_dop *einzufueg = (listenknoten_dop *) malloc(sizeof(listenknoten_dop));
 einzufueg->wert = wert;
 if (kopf==NULL) return -1;
 if (*kopf==NULL) {
    *kopf = einzufueg;
    (*kopf)->next = (*kopf)->prev = *kopf;
   }
  else {
    einzufueg->next = *kopf;
    einzufueg->prev = (*kopf)->prev;
    einzufueg->prev->next = einzufueg;
    einzufueg->next->prev = einzufueg;
    *kopf = einzufueg;
   }
 return 0;
}

void init_liste(listenknoten_dop **menge_a,listenknoten_dop **menge_b) {
 *menge_a = NULL;
 einfuegen_liste(menge_a,5);
 einfuegen_liste(menge_a,4);
 einfuegen_liste(menge_a,3);
 einfuegen_liste(menge_a,2);
 einfuegen_liste(menge_a,1);
 *menge_b = NULL;
 einfuegen_liste(menge_b,8);
 einfuegen_liste(menge_b,7);
 einfuegen_liste(menge_b,6);
 einfuegen_liste(menge_b,5);
 einfuegen_liste(menge_b,4);
 einfuegen_liste(menge_b,3);
}

int einfuegen_nach_dop(listenknoten_dop *nachdiesem, listenknoten_dop *einzufueg) {
 if ((nachdiesem==NULL)||(einzufueg==NULL)) return -1;
 einzufueg->next = nachdiesem->next;
 einzufueg->prev = nachdiesem;
 nachdiesem->next = einzufueg;
 einzufueg->next->prev = einzufueg;
 return 0;
}

int einfuegen_ende_dop(listenknoten_dop **kopf, listenknoten_dop *einzufueg) {
 if ((einzufueg==NULL)||(kopf==NULL)) return -1;
 if (*kopf==NULL) {
  *kopf = einzufueg;
  (*kopf)->next = (*kopf)->prev = *kopf;
 }
 else
  einfuegen_nach_dop((*kopf)->prev,einzufueg);
 return 0;
}

listenknoten_dop *suchen_dop(listenknoten_dop *kopf, int gesuchter_wert) {
 listenknoten_dop *laufzeiger;
 if (kopf==NULL)
  return NULL;
 laufzeiger = kopf;
 while (laufzeiger->next!=kopf&&laufzeiger->wert!=gesuchter_wert)
  laufzeiger = laufzeiger->next;
 if (laufzeiger->wert==gesuchter_wert)
   return laufzeiger;
  else
   return NULL;
}

listenknoten_dop *copy(listenknoten_dop *kn) {
 listenknoten_dop *kn_neu = (listenknoten_dop *) malloc(sizeof(listenknoten_dop));
 kn_neu->wert = kn->wert;
 kn_neu->next = kn_neu->prev = NULL;
 return kn_neu;
}

listenknoten_dop *aufg_8_6_liste(listenknoten_dop *a, listenknoten_dop *b) {
 /* Resultat = (A vereinigt mit B) ohne (A geschnitten mit B) */
 listenknoten_dop *ergebnis = NULL,
                  *laufzeiger, *hilfzeiger;
 laufzeiger = a;
 if (laufzeiger!=NULL)
  do {
   if (suchen_dop(b,laufzeiger->wert)==NULL)
     einfuegen_ende_dop(&ergebnis,copy(laufzeiger));
   laufzeiger = laufzeiger->next;
  } while (laufzeiger!=a);
 laufzeiger = b;
 if (laufzeiger!=NULL)
  do {
   if (suchen_dop(a,laufzeiger->wert)==NULL)
     einfuegen_ende_dop(&ergebnis,copy(laufzeiger));
   laufzeiger = laufzeiger->next;
  } while (laufzeiger!=b);
 return ergebnis;
}

/*** Funktionen fuer Bitmap-Darstellung ***/

#define MENGENTYP unsigned long

unsigned int size = sizeof(MENGENTYP)*8;

int hinzufuegen_bitmap(MENGENTYP *menge, unsigned int x) {
 int i;
 MENGENTYP h = 1; 
 if (x>size-1)
  return -1;
 for (i=0;i<size-1-x;i++)
  h <<= 1;
 *menge = *menge | h;
 return 0;
}

void init_bitmap(MENGENTYP *menge_a, MENGENTYP *menge_b) {
 int i;
 *menge_a = 0;
 for (i=1;i<=5;i++)
  hinzufuegen_bitmap(menge_a,i);
 *menge_b = 0;
 for (i=3;i<=8;i++)
  hinzufuegen_bitmap(menge_b,i);
}

void ausgabe_bitmap(MENGENTYP menge) {
 int i;
 for (i=size-1;i>=0;i--)
   if (menge>>i & 1)
    printf("%d ",size-1-i);
 printf("\n");
}

MENGENTYP aufg_8_6_bitmap(MENGENTYP a, MENGENTYP b) {
 /* Resultat = (A vereinigt mit B) ohne (A geschnitten mit B) */
 return (a | b) & (~ (a & b));
}

int main(void) {

 listenknoten_dop *menge_a_liste, *menge_b_liste, *ergebnis_liste; 

 MENGENTYP menge_a_bitmap, menge_b_bitmap, ergebnis_bitmap;

 /* Listenbasiert: */
 
 init_liste(&menge_a_liste,&menge_b_liste);

 ergebnis_liste = aufg_8_6_liste(menge_a_liste,menge_b_liste);

 printf("Listen-Operationen:\n\n");
 printf(" A: ");
 ausgabe_liste(menge_a_liste);
 printf("\n B: ");
 ausgabe_liste(menge_b_liste);
 printf("\n Ergebnis: ");
 ausgabe_liste(ergebnis_liste);

 /* Bitmap-basiert: */
 
 init_bitmap(&menge_a_bitmap,&menge_b_bitmap);

 ergebnis_bitmap = aufg_8_6_bitmap(menge_a_bitmap,menge_b_bitmap);

 printf("\n\nBitmap-Operationen:\n\n");
 printf(" A: ");
 ausgabe_bitmap(menge_a_bitmap);
 printf("\n B: ");
 ausgabe_bitmap(menge_b_bitmap);
 printf("\n Ergebnis: ");
 ausgabe_bitmap(ergebnis_bitmap);

 return 0;

}



